pub enum Status {
    Information,
    Success,
    Redirect,
    ClientError,
    ServerError,
}

impl Status {
    pub fn code(&self) -> &str {
        match self {
            Self::Information => "100",
            Self::Success => "200",
            Self::Redirect => "300",
            Self::ClientError => "400",
            Self::ServerError => "500",
        }
    }

    pub fn description(&self) -> &str {
        match self {
            Self::Information => "Information",
            Self::Success => "Success",
            Self::Redirect => "Redirect",
            Self::ClientError => "ClientError",
            Self::ServerError => "ServerError",
        }
    }
}

impl std::fmt::Debug for Status {
    fn fmt(&self, f: &mut std::fmt::Formatter) -> Result<(), std::fmt::Error> {
        write!(f, "{} {}", self.code(), self.description())
    }
}
